import pprint

import requests


def test_link(conn, user):
    name_id = user['name_id']
    url = conn + '/link?NameID=%s' % name_id
    payload = {
        'IDENTFAMILLE': user['family'],
        'NOM': user['last_name'],
        'PRENOM': user['first_name'],
    }
    print("Creating link with the following payload:")
    pprint.pprint(payload)
    resp = requests.post(url, json=payload)
    resp.raise_for_status()
    res = resp.json()
    pprint.pprint(res)
    assert res['err'] == 0
    print('\n')

    print("GET family info")
    url = conn + '/family_info?NameID=%s' % name_id
    resp = requests.get(url)
    resp.raise_for_status()
    data = resp.json()
    pprint.pprint(data)
    assert data['err'] == 0
    print('\n')

    print("GET children info")
    url = conn + '/children_info?NameID=%s' % (name_id)
    resp = requests.get(url)
    resp.raise_for_status()
    res = resp.json()
    pprint.pprint(res)
    assert res['err'] == 0
    print('\n')

    for child in data['data']['MEMBRE']:
        print("GET child info")
        url = conn + '/child_info?NameID=%s&idpersonne=%s' % (name_id, child['IDENT'])
        resp = requests.get(url)
        resp.raise_for_status()
        res = resp.json()
        pprint.pprint(res)
        assert res['err'] == 0
        print('\n')

    print("Deleting link")
    url = conn + '/unlink?NameID=%s' % name_id
    resp = requests.post(url)
    resp.raise_for_status()
    res = resp.json()
    pprint.pprint(res)
    assert res['err'] == 0
    print('\n')
